jQuery(document).ready(function () {
    'use strict';
    ViWec.Components.registerCategory('wtypc_woo_email', 'WooCommerce Thank You Page Customizer');
    let wtypc_woo_email = wtypc_3rd_viwec_template.coupon_gift || [];
    wtypc_woo_email.properties = [
        {
            key: "viwtypc_woo_email_coupon_before",
            inputType: SectionInput,
            name: false,
            target: '.viwtypc-woo-email-coupon-before-wrap',
            section: styleSection,
            data: {header: "Text before"},
        },
        {
            key: "viwtypc_woo_email_coupon_before_text",
            target: '.viwtypc-woo-email-coupon-before',
            htmlAttr: "innerHTML",
            section: styleSection,
            col: 16,
            inputType: TextInput,
            renderShortcode: true,
            data: {shortcodeTool: true}
        },
        {
            name: "Color",
            key: "color",
            target: '.viwtypc-woo-email-coupon-before-wrap',
            htmlAttr: "childStyle",
            section: styleSection,
            col: 8,
            inline: true,
            inputType: ColorInput
        },
        {
            name: "Font size(px)",
            key: "font-size",
            target: '.viwtypc-woo-email-coupon-before-wrap',
            htmlAttr: "childStyle",
            section: styleSection,
            col: 8,
            inline: true,
            unit: 'px',
            inputType: NumberInput
        },
        {
            name: "Font weight",
            key: "font-weight",
            target: '.viwtypc-woo-email-coupon-before-wrap',
            htmlAttr: "childStyle",
            section: styleSection,
            col: 8,
            inline: true,
            inputType: SelectInput,
            data: {
                options: viWecFontWeightOptions
            }
        },
        {
            name: "Line height(px)",
            key: "line-height",
            target: '.viwtypc-woo-email-coupon-before-wrap',
            htmlAttr: "childStyle",
            section: styleSection,
            col: 8,
            unit: 'px',
            inline: true,
            inputType: NumberInput
        },
        {
            name: "Alignment",
            key: "text-align",
            htmlAttr: "childStyle",
            target: '.viwtypc-woo-email-coupon-before-wrap',
            validValues: ["", "text-left", "text-center", "text-right"],
            section: styleSection,
            col: 8,
            inputType: RadioButtonInput,
            data: {extraClass: "left", options: viWecAlignmentOptions},
        },
        {
            key: "viwtypc_woo_email_coupon_content",
            inputType: SectionInput,
            target: '.viwtypc-woo-email-coupon-content-wrap',
            name: false,
            section: styleSection,
            data: {header: "Coupon Code"},
        },
        {
            key: "viwtypc_woo_email_coupon_content_text",
            htmlAttr: 'innerHTML',
            target: '.viwtypc-woo-email-coupon-content1',
            section: styleSection,
            col: 16,
            inputType: TextInput,
            renderShortcode: true,
            data: {shortcodeTool: true}
        },
        {
            name: "Background",
            key: "background",
            target: '.viwtypc-woo-email-coupon-content-wrap',
            htmlAttr: "childStyle",
            section: styleSection,
            col: 8,
            inline: true,
            inputType: ColorInput,
            data: {value: '#fff'}
        },
        {
            name: "Color",
            key: "color",
            target: '.viwtypc-woo-email-coupon-content',
            htmlAttr: "childStyle",
            section: styleSection,
            col: 8,
            inline: true,
            inputType: ColorInput,
            data: {value: '#222'}
        },
        {
            name: "Border width(px)",
            key: "border-width",
            htmlAttr: "childStyle",
            target: '.viwtypc-woo-email-coupon-content',
            section: styleSection,
            col: 8,
            unit: 'px',
            inputType: NumberInput,
            data: {value: 2},
        },
        {
            name: "Border radius(px)",
            key: "border-radius",
            htmlAttr: "childStyle",
            target: '.viwtypc-woo-email-coupon-content',
            section: styleSection,
            col: 8,
            unit: 'px',
            inputType: NumberInput,
            data: {value: 0},
        },
        {
            name: "Border color",
            key: "border-color",
            htmlAttr: "childStyle",
            target: '.viwtypc-woo-email-coupon-content',
            section: styleSection,
            col: 8,
            inline: true,
            inputType: ColorInput,
            data: {value: '#162447'}
        },
        {
            name: "Border style",
            key: "border-style",
            htmlAttr: "childStyle",
            target: '.viwtypc-woo-email-coupon-content',
            section: styleSection,
            col: 8,
            inline: true,
            data: {
                options: [
                    {id: 'solid', text: 'Solid'},
                    {id: 'dotted', text: 'Dotted'},
                    {id: 'dashed', text: 'Dashed'},
                ]
            },
            inputType: SelectInput
        },
        {
            groupName: "Padding(px)",
            name: "Left",
            key: "padding-left",
            htmlAttr: "childStyle",
            target: '.viwtypc-woo-email-coupon-content',
            section: styleSection,
            col: 4,
            unit: 'px',
            inputType: NumberInput,
            data: {value: 20},
        },
        {
            name: "Top",
            key: "padding-top",
            htmlAttr: "childStyle",
            target: '.viwtypc-woo-email-coupon-content',
            section: styleSection,
            col: 4,
            unit: 'px',
            inputType: NumberInput,
            data: {value: 10},
        },
        {
            name: "Right",
            key: "padding-right",
            htmlAttr: "childStyle",
            target: '.viwtypc-woo-email-coupon-content',
            section: styleSection,
            col: 4,
            unit: 'px',
            inputType: NumberInput,
            data: {value: 20},
        },
        {
            name: "Bottom",
            key: "padding-bottom",
            htmlAttr: "childStyle",
            target: '.viwtypc-woo-email-coupon-content',
            section: styleSection,
            col: 4,
            unit: 'px',
            inputType: NumberInput,
            data: {value: 10},
        },
        {
            groupName: "Margin(px)",
            name: "Left",
            key: "margin-left",
            htmlAttr: "childStyle",
            target: '.viwtypc-woo-email-coupon-content',
            section: styleSection,
            col: 4,
            unit: 'px',
            inputType: NumberInput,
            data: {value: 0},
        },
        {
            name: "Top",
            key: "margin-top",
            htmlAttr: "childStyle",
            target: '.viwtypc-woo-email-coupon-content',
            section: styleSection,
            col: 4,
            unit: 'px',
            inputType: NumberInput,
            data: {value: 20},
        },
        {
            name: "Right",
            key: "margin-right",
            htmlAttr: "childStyle",
            target: '.viwtypc-woo-email-coupon-content',
            section: styleSection,
            col: 4,
            unit: 'px',
            inputType: NumberInput,
            data: {value: 0},
        },
        {
            name: "Bottom",
            key: "margin-bottom",
            htmlAttr: "childStyle",
            target: '.viwtypc-woo-email-coupon-content',
            section: styleSection,
            col: 4,
            unit: 'px',
            inputType: NumberInput,
            data: {value: 20},
        },
        {
            name: "Alignment",
            key: "text-align",
            htmlAttr: "childStyle",
            target: '.viwtypc-woo-email-coupon-content-wrap',
            validValues: ["", "text-left", "text-center", "text-right"],
            section: styleSection,
            col: 8,
            inputType: RadioButtonInput,
            data: {extraClass: "center", options: viWecAlignmentOptions},
        },
        {
            key: "viwtypc_woo_email_coupon_after",
            inputType: SectionInput,
            target: '.viwtypc-woo-email-coupon-after-wrap',
            name: false,
            section: styleSection,
            data: {header: "Text after"},
        },
        {
            key: "viwtypc_woo_email_coupon_after_text",
            target: '.viwtypc-woo-email-coupon-after',
            htmlAttr: "innerHTML",
            section: styleSection,
            col: 16,
            inputType: TextInput,
            renderShortcode: true,
            data: {shortcodeTool: true}
        },
        {
            name: "Color",
            key: "color",
            target: '.viwtypc-woo-email-coupon-after-wrap',
            htmlAttr: "childStyle",
            section: styleSection,
            col: 8,
            inline: true,
            inputType: ColorInput
        },
        {
            name: "Font size(px)",
            key: "font-size",
            target: '.viwtypc-woo-email-coupon-after-wrap',
            htmlAttr: "childStyle",
            section: styleSection,
            col: 8,
            inline: true,
            unit: 'px',
            inputType: NumberInput
        },
        {
            name: "Font weight",
            key: "font-weight",
            target: '.viwtypc-woo-email-coupon-after-wrap',
            htmlAttr: "childStyle",
            section: styleSection,
            col: 8,
            inline: true,
            inputType: SelectInput,
            data: {
                options: viWecFontWeightOptions
            }
        },
        {
            name: "Line height(px)",
            key: "line-height",
            target: '.viwtypc-woo-email-coupon-after-wrap',
            htmlAttr: "childStyle",
            section: styleSection,
            col: 8,
            unit: 'px',
            inline: true,
            inputType: NumberInput
        },
        {
            name: "Alignment",
            key: "text-align",
            htmlAttr: "childStyle",
            target: '.viwtypc-woo-email-coupon-after-wrap',
            validValues: ["", "text-left", "text-center", "text-right"],
            section: styleSection,
            col: 8,
            inputType: RadioButtonInput,
            data: {extraClass: "left", options: viWecAlignmentOptions},
        },
    ];
    ViWec.Components.add(wtypc_woo_email);
});